org.keycloak.authentication.authenticators.x509

## Class UserIdentityExtractor

- java.lang.Object
- - org.keycloak.authentication.authenticators.x509.UserIdentityExtractor

-     public abstract class UserIdentityExtractor
      extends Object

  Version:
    $Revision: 1 $
  Author:
    Peter Nalyvayko

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `UserIdentityExtractor()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static org.keycloak.authentication.authenticators.x509.UserIdentityExtractor.OrBuilder` | `either(UserIdentityExtractor extractor)`
    `abstract Object` | `extractUserIdentity(X509Certificate[] certs)`
    `static UserIdentityExtractor` | `getCertificatePemIdentityExtractor(X509AuthenticatorConfigModel config)`
    `static UserIdentityExtractor` | `getPatternIdentityExtractor(String pattern, Function<X509Certificate[],String> func)`
    `static org.keycloak.authentication.authenticators.x509.UserIdentityExtractor.SubjectAltNameExtractor` | `getSubjectAltNameExtractor(int generalName)` Obtains the subjectAltName given a `generalName`.
    `static UserIdentityExtractor` | `getX500NameExtractor(org.bouncycastle.asn1.ASN1ObjectIdentifier identifier, Function<X509Certificate[],org.bouncycastle.asn1.x500.X500Name> x500Name)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### UserIdentityExtractor

          public UserIdentityExtractor()

  - ### Method Detail

    - #### extractUserIdentity

          public abstract Object extractUserIdentity(X509Certificate[] certs)

    - #### getPatternIdentityExtractor

          public static UserIdentityExtractor getPatternIdentityExtractor(String pattern,
                                                                          Function<X509Certificate[],String> func)

    - #### getX500NameExtractor

          public static UserIdentityExtractor getX500NameExtractor(org.bouncycastle.asn1.ASN1ObjectIdentifier identifier,
                                                                   Function<X509Certificate[],org.bouncycastle.asn1.x500.X500Name> x500Name)

    - #### getSubjectAltNameExtractor

          public static org.keycloak.authentication.authenticators.x509.UserIdentityExtractor.SubjectAltNameExtractor getSubjectAltNameExtractor(int generalName)

      Obtains the subjectAltName given a `generalName`.
      Parameters:
        `generalName` - an integer representing the general name. See `X509Certificate.getSubjectAlternativeNames()`
      Returns:
        the value from the subjectAltName extension

    - #### either

          public static org.keycloak.authentication.authenticators.x509.UserIdentityExtractor.OrBuilder either(UserIdentityExtractor extractor)

    - #### getCertificatePemIdentityExtractor

          public static UserIdentityExtractor getCertificatePemIdentityExtractor(X509AuthenticatorConfigModel config)

Copyright © 2020 JBoss by Red Hat. All rights reserved.